-- ̑ҋ@[hB
local noattack_mode

-- ItOBspB
local runaway_flag = {}

-- s[hB
local cannotrunaway_mode

-- ŌɎ擾R̃LԁB
local chara_last_status

-- ŌɎ擾^[B
local last_turn

-- ŌɎ擾R̔폢LB
local element_summoned
-- ŌɎ擾ȐLB
local element_summon
----------------------------------------------------------------------------
-- 퓬JnɌĂяoR[obN֐B
function on_battle_start()
    local mi = api_battle_get_my_master()
    noattack_mode = api_battle_get_is_defense_side(mi)
    debug_log("on_battle_start mi="..mi)
    if noattack_mode then
        debug_log("mode=true")
    else
        debug_log("mode=false")
    end
    cannotrunaway_mode = false

    local mi = api_battle_get_my_master()
    local chrcount = api_battle_get_chara_count(mi)
    for i = 0, chrcount - 1, 1 do
        runaway_flag[i] = false
    end
    element_summoned = 0
    element_summon = 0
end
----------------------------------------------------------------------------
-- ҋ@[h𑱂邩ǂ`FbNBȂ^B
local function check_noattack_mode()
    local mi = api_battle_get_my_master()
    local chrcount = api_battle_get_chara_count(mi)
    local chrlist = {}
    for ci = 0, chrcount-1 do
        table.insert(chrlist, api_battle_get_chara_status(mi, ci))
    end

    -- UB
    local modeend = false
    for i=1, chrcount do
        local chr = chrlist[i]
        -- HP܂͍U񐔂Ă邩AԈُɂȂĂUꂽƂ݂ȂB
        if chr.hp < chr.hpmax or
           chr.attackcount_plus < 0 or
           table.getn(chr.status) > 0 then
            modeend = true
            break
        end
    end
    if modeend then
        return false
    end

    -- ߐڔB
    for i=1, chrcount do
        local chr = chrlist[i]
        local nlist = api_battle_get_neighbor(chr.x, chr.y, 4) -- mɊoĂȂ̂łƂ肠4wNXߖTB
        local nsz = table.getn(nlist)
        -- LǂꂩɓGߐڂĂ^ԂB
        for n=1, nsz do
            local nmi, nci = api_battle_get_chara_on(nlist[n].x, nlist[n].y)
            if nmi ~= nil and nmi ~= mi then
                modeend = true
                break
            end
        end
        if modeend then
            return false
        end
    end
    return true
end
----------------------------------------------------------------------------
-- sʂ]B
-- mychara:s{LB
-- res:sʁB
-- master:}X^[ԍBȂ0B
local function eval_result(mychara, res, master)
    local myside = (master == res.masterindex)
    local mi, ci = api_battle_get_chara_on(res.x, res.y)
    local chara
    if mi ~= nil then
        chara = api_battle_get_chara_status(mi, ci)
    end
    local v = 0

--debug_log("EVAL="..res.systemeffect)

    if chara ~= nil then
        if res.systemeffect <= ABSORB then
            if not noattack_mode then
                v = -res.value*10
                if res.systemeffect ~= NOEFFECT then
                    v = v * 2
                end
            end
--[[
if noattack_mode then
    debug_log("noatkmode")
end
debug_log("mymaster="..master.." dmgmaster="..res.masterindex.." evalatk="..v)
]]
        elseif res.systemeffect == PLUS_PA then
            v = res.value - chara.pa_plus
        elseif res.systemeffect == PLUS_PD then
            v = res.value - chara.pd_plus
        elseif res.systemeffect == PLUS_SKILL then
            v = res.value - chara.skill_plus
        elseif res.systemeffect == PLUS_SPEED then
            v = res.value - chara.speed_plus
        elseif res.systemeffect == PLUS_MA then
            v = res.value - chara.ma_plus
        elseif res.systemeffect == PLUS_MD then
            v = res.value - chara.md_plus
        elseif res.systemeffect == PLUS_ATTACKCOUNT then
            v = res.value - chara.attackcount_plus
        elseif res.systemeffect == PLUS_HPRECOVER then
            v = res.value - chara.hprecover_plus
        elseif res.systemeffect == PLUS_MPRECOVER then
            v = res.value - chara.mprecover_plus
        elseif res.systemeffect == HPRECOVER then
            local losthp = chara.hpmax - chara.hp
            v = math.min(losthp, res.value) * 8
            if losthp > chara.hpmax / 4 then
                v = v * 2
            end
            if losthp > chara.hpmax / 2 then
                v = v * 4
            end
        elseif res.systemeffect == MPRECOVER then
            local lostmp = chara.mpmax - chara.mp
            v = math.min(lostmp, res.value)
            if lostmp > chara.mpmax *2 / 3 then
                v = v * 2
            end
        elseif res.systemeffect >= CURE_POISON and res.systemeffect <= CURE_DREAM then
            table.foreach(chara.status,
                function(s)
                    if s - POISON == res.systemeffect - CURE_POISON then
                        v = v + 50
                    end
                end
            )
        elseif res.systemeffect == CURE_ALL then
            v = 40 * table.getn(chara.status)
        elseif res.systemeffect == CHANGE_RESISTANCE then
            v = res.restype - chara.resistance[res.resattr]
            v = v * 50
--debug_log("restype="..res.restype.." charares="..chara.resistance[res.resattr].." attr="..res.resattr.." v="..v)
        elseif res.systemeffect == CHANGE_MOVETYPE then
            local curmovetype = chara.movetype
            local newmovetype = res.movetype
            local curcost = api_battle_get_movetype_totalcost(curmovetype)
            local curskill = api_battle_get_movetype_totalskill(curmovetype)
            local newcost = api_battle_get_movetype_totalcost(newmovetype)
            local newskill = api_battle_get_movetype_totalskill(newmovetype)
            local good = curcost - newcost + ((newskill - curskill) / 5)
debug_log("curcost="..curcost.." newcost="..newcost.." curskill="..curskill.." newskill="..newskill.." good="..good)
            v = v + good
        else
            debug_log("unknown effect(A) = " .. res.systemeffect)
        end
        if master ~= res.masterindex then
            v = -v
        end
--debug_log("mymaster="..master.." dmgmaster="..res.masterindex.." evalatk2="..v)
    else
        if res.systemeffect == CRASHWALL then
            if master > 0 then
                v = 10
            end
        elseif res.systemeffect == SUMMON then
            summondata = api_get_chara_data(res.summoncharaid)
            v = summondata.power
            v = (v * 75 + v * math.random(50)) / 100
            if v * 2 < mychara.power then
                v = v / 2
            elseif v > mychara.power then
                v = v * 2
            end
            if element_summon > 10 then
                v = v / 3
            elseif element_summon > 4 then
                v = v / 2
            end
            if mychara.element == ELEMENT_SUMMONED then
                -- L̏ꍇアL̏sȂB
                if mychara.power > summondata.power then
                    v = 0
                end
            end
        elseif res.systemeffect == REVIVE then
            revivedata = api_get_chara_data(res.revivecharaid)
            v = revivedata.power
        else
            debug_log("unknown effect(B) = " .. res.systemeffect)
        end
    end

    return v
end
----------------------------------------------------------------------------
-- wc̃LԂSĎ擾ĕԂB
local function get_side_chara_status(master)
    local ret = {}
    local cnt = api_battle_get_chara_count(master)
    for i = 0, cnt-1, 1 do
        ret[i] = api_battle_get_chara_status(master, i)
    end
    return ret
end
----------------------------------------------------------------------------
-- sʂ̃Xg]B
local function eval_resultlist(chara, reslist, master)
    local val = 0
    table.foreach(reslist,
        function(reskey, res)
            val = val + eval_result(chara, res, master)
        end
    )
    return val
end
----------------------------------------------------------------------------
-- Ls̃R[obN֐B
function on_chara_action()
    local movable_list = api_battle_get_movable()
    local mvactlist = {}

    -- sL̏Ԃ擾B
    local mi, ci = api_battle_get_active_chara()
    local chara = api_battle_get_chara_status(mi, ci)

    -- S\[h
    if not cannotrunaway_mode then
        -- S\[hXV
        cannotrunaway_mode = runaway_flag[ci]
        -- Brave*mCȉȂ瓦B
        local baseval = 100
        if chara.master then
            if chara.hp < chara.hpmax / 3 then
                baseval = 0
            else
                baseval = 50
            end
        end
        if chara.brave * chara.morale < baseval then
            local x, y = api_battle_get_auto_runaway()
            if x ~= nil then
--debug_log("runaway="..x..","..y)
                api_battle_set_action(x, y, ACTION_RUNAWAY, 0, 0, 0)
                runaway_flag[ci] = true
                return
            end
        end
    end

    -- SẲ\ȍsт̌ʂ擾B
    local mvact = {}
    mvact.x = chara.x
    mvact.y = chara.y
    mvact.actlist = api_battle_get_action_list(chara.x, chara.y)
--debug_log("mvact mi="..mi.." ci="..ci.." x=" .. chara.x .. " y=" .. chara.y .. " num=" .. #mvact.actlist)

--[[
    table.foreach(mvact.actlist,
        function(actkey, act)
            debug_log("act spe=" .. act.special)
        end
    )
]]

    mvactlist[0] = mvact
    local cnt = 1
    table.foreach(movable_list,
        function(k, p)
            local mvact = {}
            mvact.x = p.x
            mvact.y = p.y
            mvact.actlist = api_battle_get_action_list(p.x, p.y)
--debug_log("mvact x=" .. p.x .. " y=" .. p.y .. " num=" .. #mvact.actlist)
            if #mvact.actlist > 0 then
                mvactlist[cnt] = mvact
                cnt = cnt + 1
            end
        end
    )

--debug_log("1X")
    -- 擾ʂ]B
    local maxval = 0
    local maxact = {}
    table.foreach(mvactlist,
        function(mvactkey, mvact)
            table.foreach(mvact.actlist,
                function(actkey, act)
                    local reslist = api_battle_eval_action(mvact.x, mvact.y, act.actiontype, act.special, act.targetx, act.targety)
                    local val = eval_resultlist(chara, reslist, mi)
                    if maxval < val then
                        maxval = val
                        maxact.x = mvact.x
                        maxact.y = mvact.y
                        maxact.acttype = act.actiontype
                        maxact.special = act.special
                        maxact.targetx = act.targetx
                        maxact.targety = act.targety
                    end
                end
            )
        end
    )

--debug_log("2X")
    -- ڂłsȂsB
    if maxact.x ~= nil then
        api_battle_set_action(maxact.x, maxact.y, maxact.acttype, maxact.special, maxact.targetx, maxact.targety)
        return
    end

    -- ̑ҋ@[hXVB
    if noattack_mode then
        noattack_mode = check_noattack_mode()
        -- ̑ҋ@[hȂ牽ȂB
        if noattack_mode then
            api_battle_set_action(chara.x, chara.y, ACTION_WAIT, 0, 0, 0)
            return
        end
    end

    local movable_layer = api_battle_get_movable_layer()

    local mapw, maph = api_battle_get_map_size()
    -- sLW
    local charalocindex = chara.y * mapw + chara.x

    -- lړ͈
    local mvdist = math.max(mapw, maph) * 3
    for m=1, 3 do
        local movelayer = api_battle_get_move_layer_from(mi, ci, chara.x, chara.y, mvdist, true)

--[[
        for y=0, maph-1 do
            for x=0, mapw-1 do
                local mvchip = movelayer[index]
                local nmi, nci = api_battle_get_chara_on(x, y)
                if nmi ~= nil and nmi ~= mi then
                    if todist < mvchip.value then
                        todist = mvchip.value
                        toindex = index
                        toy = y
                    end
                end
                index = index + 1
            end
        end
]]

        local todist = 0
        local toindex, tox, toy
        local index = 0

        -- ł߂G̗אڍWTB
        local enemymaster = api_battle_get_enemy_master()
        local emcount = table.getn(enemymaster)
        for i = 1, emcount do
            local ei = enemymaster[i]
            local chrcount = api_battle_get_chara_count(ei)
            for ci = 0, chrcount-1 do
                local echr = api_battle_get_chara_status(ei, ci)
                local nlist = api_battle_get_neighbor(echr.x, echr.y, 1)
                local ncount = table.getn(nlist)
                for n = 1, ncount do
                    local np = nlist[n]
                    local index = np.y * mapw + np.x
                    local mvchip = movelayer[index]
                    if mvchip.value > 0 and todist < mvchip.value then
                        todist = mvchip.value
                        toindex = index
                        tox = np.x
                        toy = np.y
                    end
                end
            end
        end

        local foundbutcant = false
        if toindex ~= nil then
            -- Gꍇ͈ړoHHĈړ\WB
            if movable_layer[toindex] ~= 0 then
                api_battle_set_action(tox, toy, ACTION_WAIT, 0, 0, 0)
                return
            end

            while true do
--debug_log("to="..toindex)
                local fromx = movelayer[toindex].fromx
                local fromy = movelayer[toindex].fromy
                local fromindex = fromy * mapw + fromx
--debug_log("from="..fromindex)
                if movable_layer[fromindex] ~= 0 then
--debug_log("mvx="..fromx.." mvy="..fromy)
                    api_battle_set_action(fromx, fromy, ACTION_WAIT, 0, 0, 0)
                    return
                end
                -- ݂̈ړ\͈͂ɂ͈ړoHɈړ\WȂI
                if fromindex == charalocindex then
debug_log("G͌ǈړs")
                    foundbutcant = true
                    break
                end
                toindex = fromindex
            end
        end

        if foundbutcant then
            break
        end
        -- GȂꍇ͈͌͂LĂ݂B
        mvdist = mvdist * 2
    end

    api_battle_set_action(chara.x, chara.y, ACTION_WAIT, 0, 0, 0)
end
----------------------------------------------------------------------------
-- 퓬̐ߖځiLsIA^[ijŌĂяoR[obN֐B
function on_battle_progress()
    local turn = api_battle_get_turn()

    local mi = api_battle_get_my_master()
    local tmplist = get_side_chara_status(mi)
    if chara_last_status == nil then
        chara_last_status = tmplist
        return
    end

    local enemy
    if mi == 0 then
        enemy = 1
    else
        enemy = 0
    end

    local enemylist = get_side_chara_status(enemy)
    local en = table.getn(enemylist)
    local epower = 0
    for i = 0, en, 1 do
        epower = epower + enemylist[i].power * enemylist[i].hp * 2 / enemylist[i].hpmax
    end

    element_summon = 0
    element_summoned = 0
    local n = table.getn(chara_last_status)
    local mypower = 0
    for i = 0, n, 1 do
        mypower = mypower + tmplist[i].power * tmplist[i].hp * 2 / tmplist[i].hpmax
    end
    for i = 0, n, 1 do
        local oldst = chara_last_status[i]
        local newst = tmplist[i]
        local brave = newst.brave
        if newst.hp > 0 then
            -- ĂꍇB
            if oldst.hp < newst.hp then
                -- HPĂmCB
                if newst.hp == newst.hpmax then
                    brave = brave + 10 + newst.power / 20
                elseif newst.hp > newst.hpmax / 2 then
                    brave = brave + 10 + newst.power / 30
                else
                    brave = brave + 5
                end
            elseif oldst.hp > newst.hp then
                -- HPĂmCB
                if newst.hp < newst.hpmax / 3 then
                    brave = brave - 10 - newst.power / 20
                elseif newst.hp < newst.hpmax / 2 then
                    brave = brave - 10 - newst.power / 30
                else
                    brave = brave - 5
                end
            end

            -- 폢LvB
            if newst.element == ELEMENT_SUMMONED then
                element_summoned = element_summoned + 1
            elseif newst.element == ELEMENT_SUMMON then
                element_summon = element_summon + 1
            end
        else
            -- SꍇmCB
            if oldst.hp > 0 then
                brave = brave - newst.power / 10
            end
        end

        if last_turn ~= turn then
            if mypower > epower then
                brave = brave + (5 + 200 / newst.morale)
            elseif mypower < epower / 3 then
                brave = brave - (10 + 400 / newst.morale)
            elseif mypower < epower / 2 then
                brave = brave - (5 + 200 / newst.morale)
            end
            debug_log("MP = "..mypower.." EP = "..epower)
            debug_log("brave update = "..brave)
        end

        api_battle_set_chara_brave(mi, i, brave)
    end

    last_turn = turn
    chara_last_status = tmplist
end
