local TEXT_X = 128
local TEXT_Y = 8
local textline = 0

-- bEBhẼTCYȂǂݒB
function arrange_talk_window(win, num)
    local w = 512
    local h = 128
    api_window_set_size(win, w, h)
    local topw, toph = api_gui_get_top_size()
    local margin = 40
    if num == 0 then
        api_window_set_position(win, -1, toph/2 - margin - h)
    else
        api_window_set_position(win, -1, toph/2 + margin + h)
    end
    api_window_set_titlebarheight(win, 2)
    api_window_set_visible(win, false)
end

-- win\̊secb҂Bsec==-1͉̎iɑ҂B܂win̏Ń}EX{^őҋ@B
function show_window_period(win, sec)
    local oldt = api_get_msec()
    while api_window_is_visible(win) do
        local brk = false
        local ev = api_gui_event_pop()
        while ev ~= nil do
            if ev.eventtype == EVENT_MOUSELPRESSED then
                brk = true
            end
            ev = api_gui_event_pop()
        end
        if brk then
            break
        end

        if sec ~= -1 and oldt + sec < api_get_msec() then
            break
        end

        coroutine.yield()
    end
end

--[[
function talk_window(win)
    local windata = {}
    windata.handle = win
    windata.line = 0
    return windata
end

local talkx = 80
local lineskip = 18

function ofutil_window_add_text(windata, str)
    api_window_set_text(windata.handle, 80, lineskip * windata.line, str)
    windata.line = windata.line + 1
end

function ofutil_window_clear(windata)
    api_window_clear_text(windata.handle)
    api_window_clear_image(windata.handle)
    windata.line = 0
end
]]

function ofutil_window_show(win)
    api_window_set_visible(win, true)
    api_window_clear_text(win)
    api_window_clear_image(win)
end

function ofutil_master_event(masterid)
    return (masterid == api_get_current_master()) and api_master_is_player(masterid)
end

function ofutil_face(win, layer, charaid)
    api_window_set_faceorchip(win, 8, 8, layer, charaid)
end

function ofutil_reset_text()
    textline = 0
end

function ofutil_talk(win, msg)
    api_window_set_text(win, TEXT_X, TEXT_Y + textline * LINE_SKIP, LAYER_TEXT, msg)
    textline = textline + 1
end

function ofutil_narration(win, msg)
    api_window_set_text(win, -1, TEXT_Y + textline * LINE_SKIP, LAYER_TEXT, msg)
    textline = textline + 1
end

-- y/n_CAOB߂lBUTTON_YES or BUTTON_NO
function ofutil_dialog_yesno(msg)
    api_dialog_show('mF', msg, BUTTON_YES + BUTTON_NO)
    while api_dialog_is_visible() do
        coroutine.yield()
    end
    debug_log("BUTTON="..api_dialog_get_selected().." BUTTON_YES="..BUTTON_YES)
    return api_dialog_get_selected() == BUTTON_YES
end
