----------------------------------------------------------------------------
-- PGA͎̐wv߂ĕԂB
function eval_areaforce(areaid)
    local force = 0
    local chrcnt = api_scenario_get_area_chara_count(areaid)
    local i
    for i = 0, chrcnt - 1 do
        local chrst = api_scenario_get_area_chara(areaid, i)
        force = force + chrst.power
    end
    return force
end

--[[function eval_allsideforce(allareaforce, master)
    foreach(allareaforce,
        function(areaid, areadata)
end]]
----------------------------------------------------------------------------
-- ٗp
function employ_logic(mymaster, needforce, decmoney)
    while true do
        local mymasterstatus = api_get_master(mymaster)
        local money = mymasterstatus.money - decmoney
        -- Kv͂łwcGATB
        local maxforce = 0
        local maxarea
        table.foreach(needforce,
            function(areaid, nforce)
                if api_scenario_get_area_chara_count(areaid) < AREACHARA_MAX then
                    if maxforce < nforce._total then
                        maxforce = nforce._total
                        maxarea = areaid
                    end
                end
            end
        )
        if maxarea == nil then
            break
        end
--debug_log("maxarea")

        local chrcount = api_scenario_get_area_chara_count(maxarea)

        local maxpower = 0
        local empid
        local employer
        for empchr = 0, chrcount - 1 do
            local empchrst = api_scenario_get_area_chara(maxarea, empchr)
            if not empchrst.actioned then
                local employable = api_scenario_get_area_employable(maxarea, empchr)
                table.foreach(employable,
                    function(chrid, cost)
--debug_log("cost="..cost.." money="..money)
                        if cost < money then
                            local chrdata = api_get_chara_data(chrid)
                            if maxpower < chrdata.power then
                                empid = chrid
                                employer = empchr
                                maxpower = chrdata.power
                            end
                        end
                    end
                )
            end
        end

        if empid ~= nil then
debug_log("maxarea="..maxarea.." employer="..employer.." empid="..empid)
            api_scenario_employ(maxarea, employer, empid)
            needforce[maxarea]._total = needforce[maxarea]._total - maxpower
        else
            break
        end
    end
end
----------------------------------------------------------------------------
-- ow̏owGAɗאڂGΐ͂߂B
function eval_enemy_after_departure(areaid, target_areaid, allarea, alliance)
    local force = 0
    local area = allarea[areaid]
    table.foreach(area.neighbor,
        function(i, nid)
            if nid ~= target_areaid then
                local narea = allarea[nid]
                if narea.master ~= mymaster and (not alliance[narea.master]) then
                    force = force + narea.force
                end
            end
        end
    )
    return force
end
----------------------------------------------------------------------------
-- area_id̃GAow\Ȑ͂ƃLCfbNXXg𐶐ĕԂB
function get_departurable(target_areaid, areaid, allarea, alliance)
    local areachara = api_scenario_get_area_allchara(areaid)
    local indice = {}
    local depforce = 0
    local force = allarea[areaid].force
    local needforce = eval_enemy_after_departure(areaid, target_areaid, allarea, alliance)
    table.foreach(areachara,
        function(i, chara)
            if force - depforce < needforce then
                return
            end
            if not chara.actioned then
                depforce = depforce + chara.power
                table.insert(indice, i - 1)
            end
        end
    )
    return depforce, indice
end
----------------------------------------------------------------------------
-- ow̕]lB
function eval_depcand(areaid, depcand, allarea)
    if depcand.force < allarea[areaid].force then
        return 0
    end
    return depcand.force / table.getn(depcand.from)
end
----------------------------------------------------------------------------
-- ow
function departure_logic(mymaster, allarea, enemyarea, alliance)
    -- enemyareadep[owGAID]ɏowf[^B
    -- owf[^.force = ow͎wv
    -- owf[^.from = {owf[^}
    -- owf[^.areaid = owGAID
    -- owf[^.force  = owGȀow͎w
    -- owf[^.indice = {owLCfbNX}
    local enemyareadep = {}
    table.foreach(enemyarea,
        function(i, areaid)
            enemyareadep[i] = {}
            local area = allarea[areaid]
            local depcandtmp = {}
            depcandtmp.from = {}
            depcandtmp.force = 0
            depcandtmp.chrcnt = 0
            table.foreach(area.neighbor,
                function(k, nid)
                    if mymaster == api_scenario_get_area_master(nid) then
                        local depcand = {}
                        local depdata = {}
                        depcand.from = {}
                        depdata.areaid = nid
                        depcand.force, depdata.indice = get_departurable(areaid, nid, allarea, alliance)
                        if depcand.force > 0 then
                            table.insert(depcand.from, depdata)
                            table.insert(enemyareadep[i], depcand)
                            -- ow\ȗאڃGASowp^[B
                            table.insert(depcandtmp.from, depdata)
                            depcandtmp.force = depcandtmp.force + depcand.force
                            depcandtmp.chrcnt = depcandtmp.chrcnt + table.getn(depdata.indice)
                        end
                    end
                end
            )
            -- G[BŐ^ʖڂɍl悤ɂB
            if depcandtmp.chrcnt <= AREACHARA_MAX then
                table.insert(enemyareadep[i], depcandtmp)
            end
        end
    )

    local eareaindex
    local depindex
    local maxdep = 0
    table.foreach(enemyarea,
        function(i, areaid)
            table.foreach(enemyareadep[i],
                function(i2, depcand)
                    local dep = eval_depcand(areaid, depcand, allarea)
                    if maxdep < dep and depcand.force > allarea[areaid].force * 1.2 then
                        eareaindex = i
                        depindex = i2
                        maxdep = dep
                    end
                end
            )
        end
    )
    if eareaindex ~= nil then
        local charaindice = {}
        local depcand = enemyareadep[eareaindex][depindex]
        table.foreach(depcand.from,
            function(i, depdata)
                --debug_log(depdata.areaid)
                charaindice[depdata.areaid] = depdata.indice
            end
        )
        api_scenario_departure(enemyarea[eareaindex], charaindice)
    end
end
----------------------------------------------------------------------------
function find_notactioned_chara(areaid)
    local chrcnt = api_scenario_get_area_chara_count(areaid)
    local i
    for i = 0, chrcnt - 1 do
        local chrst = api_scenario_get_area_chara(areaid, i)
        if not chrst.actioned then
            return i
        end
    end
    return -1
end
----------------------------------------------------------------------------
-- GAԃLړB
function move_logic(myarea, allarea, needforce)
    local excludefromarea = {}  -- ړΏۊOGAiLt̎j

    for mv = 1, 200 do
        -- ł͂ɗ]T̂GAB
        local minneed = 1000000
        local minneedarea
        table.foreach(myarea,
            function(areaid, b)
                forcedata = needforce[areaid]
                if minneed > forcedata._total and not excludefromarea[areaid] then
                    minneed = forcedata._total
                    minneedarea = areaid
                end
            end
        )

        if minneedarea ~= nil then
            --debug_log('ړ from='..minneedarea)
            -- ł͂ɗ]T̖אڃGAB
            local maxneed = -1000000
            local maxneedarea
            local area = allarea[minneedarea]
            table.foreach(area.neighbor,
                function(i, nid)
                    local forcedata = needforce[nid]
                    local chrcnt = api_scenario_get_area_chara_count(nid)
                    if myarea[nid] and chrcnt < AREACHARA_MAX and maxneed < forcedata._total then
                        maxneed = forcedata._total
                        maxneedarea = nid
                    end
                end
            )

            -- ړ\ȃLΈړB
            if maxneedarea ~= nil then
                local chrindex = find_notactioned_chara(minneedarea)
                if chrindex ~= -1 then
                    local chrst = api_scenario_get_area_chara(minneedarea, chrindex)
                    needforce[minneedarea]._total = needforce[minneedarea]._total + chrst.power
                    needforce[maxneedarea]._total = needforce[maxneedarea]._total - chrst.power

                    if not api_scenario_move_area_chara(minneedarea, maxneedarea, {chrindex}) then
                        debug_log('vl[`ɃoOL from='..minneedarea..' to='..maxneedarea..' index='..chrindex)
                    --else
                        --debug_log('ړOK from='..minneedarea..' to='..maxneedarea..' index='..chrindex)
                    end
                else
                    excludefromarea[minneedarea] = true
                end
            end
        else
            break
        end
    end
end
----------------------------------------------------------------------------
function get_myalliance(mymaster, allmaster)
    local alliance = {}
    table.foreach(allmaster,
        function(i, masterid)
            if mymaster ~= masterid then
                alliance[masterid] = api_find_alliance(mymaster, masterid)
            end
        end
    )
    return alliance
end
----------------------------------------------------------------------------
-- אڂĂwc̋Ђ]B
function get_sideforce(mymaster, allarea, allmaster)
    local sideforce = {}
    table.foreach(allmaster,
        function(i, masterid)
            sideforce[masterid] = 0
        end
    )

    table.foreach(allarea,
        function(areaid, areadata)
            if areadata.master == mymaster then
                -- GAɗאڂĂGA̐͂wcƂɏWvB
                local nforcelist = {}
                table.foreach(areadata.neighbor,
                    function(k, nid)
                        local nmaster = allarea[nid].master
                        if nmaster ~= nil and nmaster ~= mymaster then
--debug_log("candidate mm="..mymaster.." nm="..nmaster.." f="..allarea[nid].force)
--debug_log("candidate mm="..mymaster.." nm="..nmaster.." nid="..nid)
                            if nforcelist[nmaster] == nil then
                                nforcelist[nmaster] = allarea[nid].force
                            else
                                nforcelist[nmaster] = nforcelist[nmaster] + allarea[nid].force
                            end
                        end
                    end
                )

                -- x傫Ȑ͂אڂĂ狺ЂɉZB
                table.foreach(nforcelist,
                    function(nmaster, nforce)
--debug_log("candidate nforce="..nforce.." aforce="..areadata.force)
                        if nforce > areadata.force then
                            sideforce[nmaster] = sideforce[nmaster] + 2
                        elseif nforce * 1.2 > areadata.force then
                            sideforce[nmaster] = sideforce[nmaster] + 1
                        end
                    end
                )
            end
        end
    )
    return sideforce
end
----------------------------------------------------------------------------
-- ⃊Xg𐶐B݂̓Ԃ͌ȂB
function make_alliance_candidate(mymaster, allarea, allmaster, alliance, sideforce)
    local mymasterstatus = api_get_master(mymaster)
    local money = mymasterstatus.money
    local candidate = {}
    table.foreach(allmaster,
        function(i, masterid)
            if sideforce[masterid] > 0 then
                -- ɋЂ̂Gwc邩ǂ肷B
                local other = false
                table.foreach(allmaster,
                    function(j, masterid2)
                        if masterid2 ~= mymaster and masterid2 ~= masterid and
                           sideforce[masterid2] > 0 and (not alliance[masterid2]) then
                            other = true
                        end
                    end
                )
                -- ǉB
                if other then
                    local cost = api_get_alliance_cost(mymaster, masterid)
                    --debug_log("candidate="..masterid.." cost="..cost)
                    if cost <= money then
                        table.insert(candidate, masterid)
                        --debug_log("candidate="..masterid)
                    end
                end
            end
        end
    )
    return candidate
end
----------------------------------------------------------------------------
function think_alliance(mymaster, allarea, allmaster)
    -- wc̑SĂ̓擾B
    local alliance = get_myalliance(mymaster, allmaster)

    local sideforce = get_sideforce(mymaster, allarea, allmaster)

    local candidate = make_alliance_candidate(mymaster, allarea, allmaster, alliance, sideforce)

    local n = table.getn(candidate)
    if n > 0 then
        local i = math.random(n)
        local trymaster = candidate[i]
        if alliance[trymaster] == nil or (alliance[trymaster] ~= -1 and alliance[trymaster] < 3) then
            local turn
            if alliance[trymaster] == nil then
                turn = DEFAULT_ALLIANCETURN
            else
                turn = DEFAULT_ALLIANCETURN - alliance[trymaster]
            end
            local cost = api_get_alliance_cost(mymaster, trymaster)
            api_scenario_propose_alliance(trymaster, turn, cost)
        end
    end
end
----------------------------------------------------------------------------
-- 헪^[JnɌĂяoR[obN֐B
function on_myturn()
    local mymaster = api_get_current_master()
    local allarea = api_scenario_get_allarea()
    local allmaster = api_get_allmaster()

debug_log("MASTER="..mymaster)
    -- wc̑SĂ̓擾B
    local alliance = get_myalliance(mymaster, allmaster)
    --[[
    local alliance = {}
    table.foreach(allmaster,
        function(i, masterid)
            if mymaster ~= masterid then
                alliance[masterid] = api_find_alliance(mymaster, masterid)
            end
        end
    )
    ]]

    if false then
        api_scenario_endturn()
        return
    end

    -- SGA͎̐w擾B
    table.foreach(allarea,
        function(areaid, areadata)
            allarea[areaid].force = eval_areaforce(areaid)
        end
    )

    -- 
    --local tryalliancemaster = think_alliance(mymaster, allarea, allmaster)
    local tryalliancemaster
    think_alliance(mymaster, allarea, allmaster)
    alliance = get_myalliance(mymaster, allmaster)

    -- needforce[GAID][wcID]ɕKv͂B͐wcID=''
    local needforce = {}    -- L[FGAID@lFz@z̃L[FwcID@z̒lFKv
    table.foreach(allarea,
        function(areaid, areadata)
            needforce[areaid] = {}
            table.foreach(allmaster,
                function(i, masterid)
                    needforce[areaid][masterid] = 0
                end
            )
            needforce[areaid][''] = 0
            needforce[areaid]._total = 0
        end
    )

    -- wcGA̗אړG΃GAIDXg𐶐B
    local enemyarea = {}    -- lFłȂ}X^[܂͒̃GÃGAIDB
    local myarea = {}       -- L[FGAID@lFwc̃GAȂtrueB
    table.foreach(allarea,
        function(areaid, areadata)
            if areadata.master == mymaster then
                myarea[areaid] = true
                table.foreach(areadata.neighbor,
                    function(k, nid)
                        local nmaster = allarea[nid].master
                        if nmaster ~= nil then
                            if nmaster ~= mymaster and (not alliance[nmaster]) and nmaster ~= tryalliancemaster then
                                local nforce = allarea[areaid].force
                                needforce[areaid][nmaster] = needforce[areaid][nmaster] + nforce
                                needforce[areaid]._total = needforce[areaid]._total + nforce
                                table.insert(enemyarea, nid)
                            end
                        else
                            local nforce = allarea[areaid].force
                            needforce[areaid]._total = needforce[areaid]._total + nforce
                            needforce[areaid][''] = needforce[areaid][''] + nforce
                            table.insert(enemyarea, nid)
                        end
                    end
                )
            end
        end
    )

    -- ٗp
    local decmoney = 0
    if tryalliancemaster ~= nil then
        decmoney = api_get_alliance_cost(mymaster, tryalliancemaster)
    end
    employ_logic(mymaster, needforce, decmoney)

    -- ow
    if api_get_progressed_turn() > 1 then
        departure_logic(mymaster, allarea, enemyarea, alliance)
    end

    -- ړ
    move_logic(myarea, allarea, needforce)

    api_scenario_endturn()
end
----------------------------------------------------------------------------
-- \܂ꂽɌĂяoR[obN֐B
function on_proposed_alliance(masterid, mymaster)
    local allarea = api_scenario_get_allarea()
    -- SGA͎̐w擾B
    table.foreach(allarea,
        function(areaid, areadata)
            allarea[areaid].force = eval_areaforce(areaid)
        end
    )

    local allmaster = api_get_allmaster()
    local alliance = get_myalliance(mymaster, allmaster)
    local sideforce = get_sideforce(mymaster, allarea, allmaster)
    local candidate = make_alliance_candidate(mymaster, allarea, allmaster, alliance, sideforce)

    -- ̓ɂΖœB
    local ret = false
    table.foreach(candidate,
        function(i, masterid2)
            --debug_log("MAS="..masterid.." CAN="..masterid2)
            if masterid == masterid2 then
                ret = true
            end
        end
    )
    return ret
end
