require('ofutil')

local LAYER_IMAGE = 0
local LAYER_TEXT = 0

function MasterDead()
    local masters = api_last_dead_master()
    local masternames = {}
    for i, mid in ipairs(masters) do
        local masterdata = api_get_master(mid)
        if masterdata.player then
            table.insert(masternames, masterdata.name)
        end
    end
    if table.maxn(masternames) == 0 then
        -- vC[܂܂ĂȂȂIB
        return
    end

    api_music_set('I肾[.mid')
    local win = api_window_new()
    api_window_set_size(win, 256, 300 + 20 * table.getn(masters))
    api_window_set_position(win, -1, -1)
    local img = api_image_load('DEAD.png')
    if img == nil then
        return
    end
    api_window_set_image(win, 0, 0, LAYER_IMAGE, IMAGE_EVENT, img)
    api_window_set_visible(win, true)
    if table.getn(masters) == 0 then
        api_window_set_text(win, -1, 264, LAYER_TEXT, '}X^[SɃoOB')
        return
    end
    local y = 264
    --[[
    for i, mid in ipairs(masters) do
        local masterdata = api_get_master(mid)
        api_window_set_text(win, -1, y, LAYER_TEXT, masterdata.name)
        y = y + 20
    end
    ]]
    for i, mname in ipairs(masternames) do
        api_window_set_text(win, -1, y, LAYER_TEXT, mname)
        y = y + 20
    end
    api_window_set_text(win, -1, y + 4, LAYER_TEXT, 'u𔼂΂ɂē|ꂽ')
    show_window_period(win, 3)
    api_window_set_visible(win, false)
end

function GameOver()
    api_music_set('I肾[.mid')
    local win = api_window_new()
    api_window_set_size(win, 256, 256)
    api_window_set_position(win, -1, -1)
    local img = api_image_load('GameOver.png')
    api_window_set_image(win, 0, 0, LAYER_IMAGE, IMAGE_EVENT, img)
    api_window_set_visible(win, true)
    show_window_period(win, -1)
    api_window_set_visible(win, false)
end

function ComMasterEnd()
    api_music_set('I肾[.mid')
    local win = api_window_new()
    api_window_set_size(win, 480, 256)
    api_window_set_position(win, -1, -1)
    local mid = api_get_win_master()
    local masterdata = api_get_master(mid)
    api_window_set_text(win, -1, -1, LAYER_TEXT, masterdata.name..'嗤𐧔e')
    api_window_set_visible(win, true)
    show_window_period(win, -1)
end

function OnTurnEndButton()
    if ofutil_dialog_yesno('^[I܂H') then
        api_scenario_endturn()
    end
end

